<?php
/**
 * WHMCS WayForPay Payment Gateway Module
 *
 *
 * @copyright Copyright (c) ITos 2016
 * http://itos.dp.ua
 */

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

function gatewaymodule_MetaData()
{
    return array(
        'DisplayName' => 'WayForPay',
        'APIVersion' => 1.1
    );
}

function wayforpay_config()
{
    return array(
        'FriendlyName' => array(
            'Type' => 'System',
            'Value' => 'WayForPay'
        ),
        'merchantAccount' => array(
            'FriendlyName' => 'merchantAccount',
            'Type' => 'text',
            'Size' => '255',
            'Default' => ''
        ),
        'secretKey' => array(
            'FriendlyName' => 'SecretKey',
            'Type' => 'password',
            'Size' => '255',
            'Default' => ''
        ),
        'merchantDomainName' => array(
            'FriendlyName' => 'merchantDomainName',
            'Type' => 'text',
            'Size' => '255',
            'Default' => ''
        )
    );
}

function wayforpay_link($params)
{
    // Gateway Configuration Parameters
    $merchantAccount = $params['merchantAccount'];
    $secretKey = $params['secretKey'];
    $merchantDomainName = $params['merchantDomainName'];
    // Invoice Parameters
    $invoice_id = $params['invoiceid'];
    $description = "Invoice#$invoice_id";
    $amount = (string)$params['amount'];
    // Client Parameters
    $email = $params['clientdetails']['email'];
    $phone = $params['clientdetails']['phonenumber'];
    // System Parameters
    $systemUrl = $params['systemurl'];
    $returnUrl = $params['returnurl'];
    $langPayNow = $params['langpaynow'];
    $moduleName = $params['paymentmethod'];
    $url = 'https://secure.wayforpay.com/pay';
    $postfields = array();
    $postfields['merchantAccount'] = $merchantAccount;
    $postfields['merchantDomainName'] = $merchantDomainName;
    $postfields['merchantTransactionSecureType'] = 'AUTO';
    $postfields['returnUrl'] = $returnUrl;
    $postfields['serviceUrl'] = $systemUrl . '/modules/gateways/callback/' . $moduleName . '.php';
    $postfields['orderReference'] = $invoice_id . '/' . time();
    $postfields['orderDate'] = time();
    $postfields['amount'] = $amount;
    $postfields['currency'] = 'UAH';
    $postfields['productName[]'] = $description;
    $postfields['productPrice[]'] = $amount;
    $postfields['productCount[]'] = 1;
    $postfields['clientEmail'] = $email;
    if ($phone != null)
        $postfields['clientPhone'] = $phone;
    if ($params['basecurrency'] == 'USD' || $params['basecurrency'] == 'EUR' || $params['basecurrency'] == 'RUB')
    {
        $postfields['alternativeAmount'] = $params['basecurrencyamount'];
        $postfields['alternativeCurrency'] = $params['basecurrency'];
    }
    $postfields['merchantSignature'] = '';
    $postfields['merchantSignature'] .= $postfields['merchantAccount'] . ';';
    $postfields['merchantSignature'] .= $postfields['merchantDomainName'] . ';';
    $postfields['merchantSignature'] .= $postfields['orderReference'] . ';';
    $postfields['merchantSignature'] .= $postfields['orderDate'] . ';';
    $postfields['merchantSignature'] .= $postfields['amount'] . ';';
    $postfields['merchantSignature'] .= $postfields['currency'] . ';';
    $postfields['merchantSignature'] .= $postfields['productName[]'] . ';';
    $postfields['merchantSignature'] .= $postfields['productCount[]'] . ';';
    $postfields['merchantSignature'] .= $postfields['productPrice[]'];
    $postfields['merchantSignature'] = hash_hmac('md5', $postfields['merchantSignature'], $secretKey);

    $htmlOutput = '<form method="post" action="' . $url . '">';
    foreach ($postfields as $k => $v) {
        $htmlOutput .= '<input type="hidden" name="' . $k . '" value="' . $v . '" />';
    }
    $htmlOutput .= '<input type="submit" value="' . $langPayNow . '" />';
    $htmlOutput .= '</form>';
    return $htmlOutput;
}
